var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { isViewMode } from '@reltio/mdm-sdk';
import { ReadOnlyAttributesView } from '../ReadOnlyAttributesView';
import { EditModeAttributesView } from '../EditModeAttributesView';
import { EntityContext } from '../contexts/EntityContext';
import { useMdmEntityWithDiff, useMdmMode } from '../contexts/MdmModuleContext';
import { AlwaysVisibleAttributesContext } from '../contexts/AlwaysVisibleAttributesContext';
export var AttributesView = function (_a) {
    var attributesCount = _a.attributesCount, pinnedAttributes = _a.pinnedAttributes, _b = _a.alwaysVisible, alwaysVisible = _b === void 0 ? [] : _b, restProps = __rest(_a, ["attributesCount", "pinnedAttributes", "alwaysVisible"]);
    var mdmEntity = useMdmEntityWithDiff();
    var mdmMode = useMdmMode();
    var entity = restProps.entity || mdmEntity;
    var mode = restProps.mode || mdmMode;
    return (React.createElement(EntityContext.Provider, { value: entity },
        React.createElement(AlwaysVisibleAttributesContext.Provider, { value: alwaysVisible }, isViewMode(mode) ? (React.createElement(ReadOnlyAttributesView, __assign({}, restProps, { attributesCount: attributesCount, entity: entity }))) : (React.createElement(EditModeAttributesView, __assign({}, restProps, { mode: mode, pinnedAttributes: pinnedAttributes, entity: entity }))))));
};
